---
title: AdminHttpApplication (<code>admin.json</code>)
description: The AdminHttpApplication serves requests on the administrative route, such as the creation of routes and the collection of monitoring information. The administrative route and its subroutes are reserved for administration endpoints.
component: pinggateway
version: 7.2
page_id: pinggateway:reference:AdminHttpApplication
canonical_url: https://docs.pingidentity.com/pinggateway/2026/reference/AdminHttpApplication.html
llms_txt: https://docs.pingidentity.com/pinggateway/llms.txt
docs_for_agents: https://developer.pingidentity.com/build-with-ai/docs-for-agents.md
revdate: 2025-08-13T11:08:28Z
superseded_by: https://docs.pingidentity.com/pinggateway/2026/reference/AdminHttpApplication.html
section_ids:
  admin-default-objects: Default objects
  auto-created-objects: Provided objects
  AdminHttpApplication-usage: Usage
  AdminHttpApplication-properties: Properties
  AdminHttpApplication-example: Example configuration files
  AdminHttpApplication-example-default: Default configuration
  AdminHttpApplication-example-overriding: Overriding the default ApiProtectionFilter
  AdminHttpApplication-moreinfo: More information
---

# AdminHttpApplication (`admin.json`)

The AdminHttpApplication serves requests on the administrative route, such as the creation of routes and the collection of monitoring information. The administrative route and its subroutes are reserved for administration endpoints.

The configuration is loaded from a JSON-encoded file, expected at `$HOME/.openig/config/admin.json`. Objects configured in `admin.json` cannot be used by `config.json` or any IG routes.

## Default objects

IG provides default objects in `admin.json`. To override a default object, configure an object with the same name in `admin.json`.

Configure default objects in `admin.json` and `config.json` seperately. An object configured in `admin.json` with the same name as an object configured in `config.json` is not the same object.

* `AuditService`

  Records no audit events. The default AuditService is `NoOpAuditService`. For more information, see [NoOpAuditService](AuditFramework.html#NoOpAuditService).

* `CaptureDecorator`

  Captures requests and response messages. The default CaptureDecorator is named `capture`. For more information, see [CaptureDecorator](Decorators.html#CaptureDecorator).

* `ClientHandler`

  Communicates with third-party services. For more information, see [ClientHandler](Handlers.html#ClientHandler).

* `ForgeRockClientHandler`

  Sends ForgeRock Common Audit transaction IDs when communicating with protected applications. The default ForgeRockClientHandler is a Chain, composed of a TransactionIdOutboundFilter and a ClientHandler.

* `ProxyOptions`

  A proxy to which a [ClientHandler](ClientHandler.html) or [ReverseProxyHandler](ReverseProxyHandler.html) can submit requests, and an [AmService](AmService.html) can submit Websocket notifications. For more information, see [ProxyOptions](ProxyOptions.html).

* `ReverseProxyHandler`

  Communicates with third-party services. For more information, see [ReverseProxyHandler](Handlers.html#ReverseProxyHandler).

* `ScheduledExecutorService`

  Specifies the number of threads in a pool.

* `SecretsService`

  Manages a store of secrets from files, system properties, and environment variables, by using Commons Secrets Service. The default SecretsService is a SystemAndEnvSecretStore with the default configuration. For more information, see [Secrets](secrets.html).

* `TemporaryStorage`

  Manages temporary buffers. For more information, see [TemporaryStorage](MiscellaneousConfigurationObjects.html#TemporaryStorage).

* `TimerDecorator`

  Records time spent within filters and handlers. The default TimerDecorator is named `timer`. For more information, see [TimerDecorator](Decorators.html#TimerDecorator).

* `TransactionIdOutboundFilter`

  Inserts the ID of a transaction into the header of a request.

## Provided objects

IG creates the following objects when a filter with the name of the object is declared in `admin.json`:

* `"ApiProtectionFilter"`

  A filter to protect administrative APIs on reserved routes. By default, only the loopback address can access reserved routes.

  For an example that uses an ApiProtectionFilter, see [Set up the UMA example](../gateway-guide/uma.html#uma-configuration). For information about reserved routes, see [Reserved routes](preface.html#reserved-routes).

* `"MetricsProtectionFilter"`

  A filter to protect the monitoring endpoints.

  By default, the Prometheus Scrape Endpoint and Common REST Monitoring Endpoint are open and accessible; no special credentials or privileges are required to access the monitoring endpoints.

  For an example that uses a MetricsProtectionFilter, see [Protect monitoring endpoints](../maintenance-guide/monitoring.html#proc-monitor-plat-protect).

* `"StudioProtectionFilter"`

  A filter to protect the Studio endpoint when IG is running in development mode.

  When IG is running in development mode, by default the Studio endpoint is open and accessible.

  For an example that uses a StudioProtectionFilter, see [Restricting access to Studio](../studio-guide/restrict-access.html).

## Usage

```json
{
  "heap": [ object, ... ],
  "connectors": [ object, ... ],
  "vertx": object,
  "gatewayUnits": configuration expression<number>,
  "mode": configuration expression<enumeration>,
  "prefix": configuration expression<string>,
  "properties": object,
  "secrets": {
    "stores": [ SecretStore reference, ... ]
  },
  "temporaryDirectory": configuration expression<string>,
  "temporaryStorage": TemporaryStorage reference,
  "preserveOriginalQueryString": configuration expression<boolean>,
  "session": object,
  "streamingEnabled": configuration expression<boolean>
}
```

## Properties

* `"heap"`: *array of [objects](preface.html#definition-object), optional*

  The heap object configuration, described in [Heap Objects](RequiredConfiguration.html#heap-objects).

  You can omit an empty array. If you only have one object in the heap, you can inline it as the handler value.

* `"connectors"`: *array of [objects](preface.html#definition-object), required*

  Supported only for IG in standalone mode.

  Server port configuration, when IG is server-side.

  When an application sends requests to IG, or requests services from IG, IG is acting as a server of the application (server-side), and the application is acting as a client.

  ```json
  {
    "connectors" : [
      {
        "port": [ configuration expression<number>, ... ],
        "tls": ServerTlsOptions reference,
        "vertx": object
      },
      {
        ...
      }
    ]
  }
  ```

  * `port`: *array of configuration expression<[numbers](preface.html#definition-number)>, required*

    One or more ports on which IG is connected. When more than one port is defined, IG is connected to each port.

  * `tls`: *ServerTlsOptions [reference](preface.html#definition-reference), optional*

    Configure options for connections to TLS-protected endpoints, based on [ServerTlsOptions](MiscellaneousConfigurationObjects.html#ServerTlsOptions). Define the object inline or in the heap.

    Default: Connections to TLS-protected endpoints are not configured.

  * `vertx`: *[object](preface.html#definition-object), optional*

    Vert.x-specific configuration for this connector, where IG does not provide its own first-class configuration. Vert.x options are described in [HttpServerOptions](https://vertx.io/docs/apidocs/io/vertx/core/http/HttpServerOptions.html).

    For properties where IG provides its own first-class configuration, Vert.x configuration options are disallowed, and the IG configuration option takes precedence over Vert.x options configured in `vertx`. Vert.x values are evaluated as configuration expressions.

    The following Vert.x configuration options are disallowed server-side:

    * `port`

    * `useAlpn`

    * `ssl`

    * `enabledCipherSuites`

    * `enabledSecureTransportProtocols`

    * `jdkSslEngineOptions`

    * `keyStoreOptions`

    * `openSslEngineOptions`

    * `pemKeyCertOptions`

    * `pemTrustOptions`

    * `pfxKeyCertOptions`

    * `pfxTrustOptions`

    * `trustStoreOptions`

    * `clientAuth`

      The following example configures Vert.x-specific options for the connection on 8080, and TLS options for the connection on 8443:

      ```json
      {
        "connectors": [{
          "port": 8080,
          "vertx": {
            "maxWebSocketFrameSize": 128000,
            "maxWebSocketMessageSize": 256000,
            "compressionLevel": 4,
            "maxHeaderSize": 16384
          }
        },
        {
          "port": 8443,
          "tls": "ServerTlsOptions-1"
        }]
      }
      ```

* `vertx`: *[object](preface.html#definition-object), optional*

  Supported only for IG in standalone mode. Vert.x-specific configuration used to more finely-tune Vert.x instances.

  Vert.x values are evaluated as configuration expressions.

  Use the Vert.x options described in [VertxOptions](https://vertx.io/docs/apidocs/io/vertx/core/VertxOptions.html), with the following exceptions:

  * `metricsOptions`: Not used

  * `metricsEnabled`: Enable Vertx metrics. Default: `true`.

  For an example, see [Monitoring Services](../maintenance-guide/monitoring.html#monitor-vertx-prometheus).

  IG proxies all WebSocket subprotocols by default. To proxy specific WebSocket subprotocols only, list them as follows:

  ```json
  "vertx": {
    "webSocketSubProtocols": ["v1.notifications.forgerock.org", ... ]
  }
  ```

* `"gatewayUnits"`: *configuration expression<[number](preface.html#definition-number)>, optional*

  Supported only for IG in standalone mode.

  The number of parallel instances of IG to bind to an event loop. All instances listen on the same ports.

  Default: The number of cores available to the JVM.

* `mode`: *configuration expression<[enumeration](preface.html#definition-enumeration)>, optional*

  Set the IG mode to `development` or `production`. The value is not case-sensitive.

  * **Development mode (mutable mode)**

    In development mode, by default all endpoints are open and accessible.

    You can create, edit, and deploy routes through IG Studio, and manage routes through Common REST, without authentication or authorization.

    Use development mode to evaluate or demo IG, or to develop configurations on a single instance. This mode is not suitable for production.

    For information about how to switch to development mode, see [Switching from production mode to development mode](../getting-started/next-steps.html#dev-mode-switch).

    For information about restricting access to Studio in development mode, see [Restricting access to Studio](../studio-guide/restrict-access.html).

  * **Production mode (immutable mode)**

    In production mode, the `/routes` endpoint is not exposed or accessible.

    Studio is effectively disabled, and you cannot manage, list, or even read routes through Common REST.

    By default, other endpoints, such as `/share` and `api/info` are exposed to the loopback address only. To change the default protection for specific endpoints, configure an ApiProtectionFilter in `admin.json` and add it to the IG configuration.

    For information about how to switch to production mode, see [Switching from development mode to production mode](../maintenance-guide/immutable.html).

    If `mode` is not set, the provided configuration token `ig.run.mode` can be resolved at startup to define the run mode.

    Default: `production`

* `"prefix"`: *configuration expression<[string](preface.html#definition-string)>, optional*

  The base of the route for administration requests. This route and its subroutes are reserved for administration endpoints.

  Default: `openig`

* `"properties"`: *[object](preface.html#definition-object), optional*

  Configuration parameters declared as property variables for use in the configuration. See also [Route properties](Properties.html).

  Default: Null

* `"secrets"`: *SecretStore [reference](preface.html#definition-reference), optional*

  |   |                                                                                                                                                                                 |
  | - | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
  |   | This property is deprecated; use [SecretsProvider](SecretsProvider.html) instead. For more information, refer to [Deprecation](../release-notes/deprecated-functionality.html). |

  One or more secret stores, as defined in [Secrets object and secret stores](secrets.html).

* `"temporaryDirectory"`: *configuration expression<[string](preface.html#definition-string)>, optional*

  Directory containing temporary storage files.

  Set this property to store temporary files in a different directory, for example:

  ```json
  {
     "temporaryDirectory": "/path/to/my-temporary-directory"
  }
  ```

  Default: `$HOME/.openig/tmp` (on Windows,`%appdata%\OpenIG\tmp`)

* `"temporaryStorage"`: *TemporaryStorage [reference](preface.html#definition-reference), optional*

  The [TemporaryStorage](TemporaryStorage.html) object to buffer content during processing.

  Provide the name of a [TemporaryStorage](TemporaryStorage.html) object defined in the heap, or an inline TemporaryStorage configuration object.

  Incoming requests use the temporary storage buffer as follows:

  * For standalone mode only when `streamingEnabled` is `false`:

    * The request is loaded into the IG storage defined in `temporaryStorage`, before it enters the chain.

    * If the content length of a request is more than the buffer limit, IG returns an `HTTP 413 Payload Too Large`.

  * For web container mode:

    * The request is loaded into the web container buffer, which is managed externally.

    * IG does not access the web container buffer until a filter, handler, or other object tries to access the request body.

    * At that point, IG transfers the content of the web container buffer to its own temporary storage.

    * If the web container buffer is bigger than the IG temporary storage, a buffer exception occurs.

  Default: Use the heap object named TemporaryStorage. Otherwise use an internally-created TemporaryStorage object that is named TemporaryStorage, and that uses default settings for a TemporaryStorage object.

- `"preserveOriginalQueryString"`: *configuration expression<[boolean](preface.html#definition-boolean)>, optional*

  Process query strings in URLs, by applying or not applying a decode/encode process to the whole query string.

  The following characters are disallowed in query string URL components: `"`, `{`, `}`, `<`, `>`, (space), and `|`. For more information about which query strings characters require encoding, see [Uniform Resource Identifier (URI): Generic Syntax](https://www.rfc-editor.org/rfc/rfc3986).

  * `true`: Preserve query strings as they are presented.

    Select this option if the query string must not change during processing, for example, in signature verification.

    If a query string contains a disallowed character, the request produces a `400 Bad Request`.

  * `false`: Tolerate disallowed characters in query string URL components, by applying a decode/encode process to the whole query string.

    Select this option when a user agent or client produces query searches with disallowed characters. IG transparently encodes the disallowed characters before forwarding requests to the protected application.

    Characters in query strings are transformed as follows:

    * Allowed characters are not changed. For example, `sep=a` is not changed.

    * Percent-encoded values are re-encoded when the decoded value is an allowed character. For example, `sep=%27` is changed to `sep='`, because `'` is an allowed character.

    * Percent-encoded values are not changed when the decoded value is a disallowed character. For example, `sep=%22` is not changed, because `"` is a disallowed character.

    * Disallowed characters are encoded. For example, `sep="`, is changed to `sep=%22`, because `"` is a disallowed character.

  Default: `false`

- `"session"`: *[object](preface.html#definition-object), optional*

  |   |                                           |
  | - | ----------------------------------------- |
  |   | Supported only for IG in standalone mode. |

  Configures stateful sessions for IG in standalone mode. For information about IG sessions, see [Sessions](../gateway-guide/about.html#about-sessions).

  ```json
  {
    "session": {
      "cookie": {
        "name": configuration expression<string>,
        "httpOnly": configuration expression<boolean>,
        "path": configuration expression<string>,
        "sameSite": configuration expression<enumeration>,
        "secure": configuration expression<boolean>,
      },
      "timeout": configuration expression<duration>
    }
  }
  ```

  * `"cookie"`: *[object](preface.html#definition-object), optional*

    The configuration of the cookie used to store the stateful session.

    Default: The session cookie is treated as a host-based cookie.

    * `"name"`: *configuration expression<[string](preface.html#definition-string)>, optional*

      The session cookie name.

      Default: `IG_SESSIONID`

    * `"httpOnly"`: *configuration expression<[boolean](preface.html#definition-boolean)>, optional*

      Flag to mitigate the risk of client-side scripts accessing protected session cookies.

      Default: `true`

    * `"path"`: *configuration expression<[string](preface.html#definition-string)>, optional*

      The path protected by the session.

      Set a path only if the user-agent is able to re-emit session cookies on the path. For example, to re-emit a session cookie on the path `/home/cdsso`, the user-agent must be able to access that path on its next hop.

      Default: `/`.

    * `"sameSite"`: *configuration expression<[enumeration](preface.html#definition-enumeration)>, optional*

      Options to manage the circumstance in which the session cookie is sent to the server. The following values are listed in order of strictness, with most strict first:

      * `STRICT`: Send the session cookie only if the request was initiated from the session cookie domain. Not case-sensitive. Use this value to reduce the risk of cross-site request forgery (CSRF) attacks.

      * `LAX`: Send the session cookie only with GET requests in a first-party context, where the URL in the address bar matches the session cookie domain. Not case-sensitive. Use this value to reduce the risk of cross-site request forgery (CSRF) attacks.

      * `NONE`: Send the session cookie whenever a request is made to the session cookie domain. With this setting, consider setting `secure` to `true` to prevent browsers from rejecting the session cookie. For more information, see [SameSite cookies](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Set-Cookie/SameSite)

      Default: `LAX`

      |   |                                                                                                                                                                                                                                                                                                                              |
      | - | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
      |   | For CDSSO, set `"sameSite":"none"` and `"secure":"true"`. For security reasons, many browsers require the connection used by the browser to be secure (HTTPS) for `"sameSite":"none"`. Therefore, if the connection used by the browser is not secure (HTTP), the browser might not supply cookies with `"sameSite":"none"`. |

    * `"secure"`: *configuration expression<[boolean](preface.html#definition-boolean)>, optional*

      Flag to limit the scope of the session cookie to secure channels.

      Set this flag only if the user-agent is able to re-emit session cookies over HTTPS on its next hop. For example, to re-emit a session cookie with the `secure` flag, the user-agent must be connected to its next hop by HTTPS.

      Default: `false`

      |   |                                                                                                                                                                                                                                                                                                                              |
      | - | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
      |   | For CDSSO, set `"sameSite":"none"` and `"secure":"true"`. For security reasons, many browsers require the connection used by the browser to be secure (HTTPS) for `"sameSite":"none"`. Therefore, if the connection used by the browser is not secure (HTTP), the browser might not supply cookies with `"sameSite":"none"`. |

  * `"timeout"`: *configuration expression<[duration](preface.html#definition-duration)>, optional*

    The duration after which idle sessions are automatically timed out.

    The value must be above zero, and no greater than 3650 days (approximately 10 years). IG truncates the duration of longer values to 3650 days.

    Default: 30 minutes

- `"streamingEnabled"`: *configuration expression<[boolean](preface.html#definition-boolean)>, optional*

  |   |                                           |
  | - | ----------------------------------------- |
  |   | Supported only for IG in standalone mode. |

  When `true`, the content of HTTP requests and responses is streamed; it is available for processing bit-by-bit, as soon as it is received.

  When `false`, the content is buffered into the storage defined in `temporaryStorage`, and is available for processing after it has all been received.

  When this property is `true`, consider the following requirements to prevent IG from blocking an executing thread to wait for streamed content:

  * Runtime expressions that consume streamed content **must** be written with `#` instead of `$`.

    For more information, see [runtime expression](Expressions.html#runtime-expression).

  * In scripts and Java extensions, never use a `Promise` blocking method, such as `get()`, `getOrThrow()`, or `getOrThrowUninterruptibly()`, to obtain the response.

    For more information, see [Scripts](Scripts.html).

Default: `false`

## Example configuration files

### Default configuration

When your configuration does not include an `admin.json` file, the following `admin.json` is provided by default:

* Standalone mode

* Web container mode

```json
{
  "prefix": "openig",
  "connectors": [
    { "port" : 8080 }
  ]
}
```

```json
{
  "prefix": "openig",
  "connectors": [
    { "port" : 8080 }
  ]
}
```

### Overriding the default ApiProtectionFilter

The following example shows an `admin.json` file configured to override the default `ApiProtectionFilter` that protects the reserved administrative route. This example is used in [Set up the UMA example](../gateway-guide/uma.html#uma-configuration).

* Standalone mode

* Web container mode

```json
{
  "prefix": "openig",
  "connectors": [
    { "port" : 8080 }
  ],
  "heap": [
    {
      "name": "ClientHandler",
      "type": "ClientHandler"
    },
    {
      "name": "ApiProtectionFilter",
      "type": "CorsFilter",
      "config": {
        "policies": [
          {
            "acceptedOrigins": [ "http://app.example.com:8081" ],
            "acceptedMethods": [ "GET", "POST", "DELETE" ],
            "acceptedHeaders": [ "Content-Type" ]
          }
        ]
      }
    }
  ]
}
```

```json
{
  "prefix": "openig",
  "heap": [
    {
      "name": "ClientHandler",
      "type": "ClientHandler"
    },
    {
      "name": "ApiProtectionFilter",
      "type": "CorsFilter",
      "config": {
        "policies": [
          {
            "acceptedOrigins": [ "http://app.example.com:8081" ],
            "acceptedMethods": [ "GET", "POST", "DELETE" ],
            "acceptedHeaders": [ "Content-Type" ]
          }
        ]
      }
    }
  ]
}
```

## More information

[org.forgerock.openig.http.AdminHttpApplication](../_attachments/apidocs/org/forgerock/openig/http/AdminHttpApplication.html)
